import { Player, system, world } from "@minecraft/server"
import { ModalFormData } from "@minecraft/server-ui"

system.afterEvents.scriptEventReceive.subscribe((data) => {
    if (data.id !== "title:form") return;
    const form = new ModalFormData
    form.title({
        translate: "form.titles.title"
    })
    let options1 = [
        tr("form.select.center"),
        tr("form.select.topright"),
        tr("form.select.topleft"),
        tr("form.select.bottomright"),
        tr("form.select.bottomleft")
    ]
    let options1_a = [
        "center",
        "top_right",
        "top_left",
        "bottom_right",
        "bottom_left"
    ]
    let options2 = [
        tr("form.animation.offset_up"),
        tr("form.animation.offset_down"),
        tr("form.animation.offset_right"),
        tr("form.animation.offset_left"),
        tr("form.animation.offset_up_back"),
        tr("form.animation.offset_down_back"),
        tr("form.animation.offset_left_back"),
        tr("form.animation.offset_right_back"),
        tr("form.animation.offset_up_smooth"),
        tr("form.animation.offset_down_smooth"),
        tr("form.animation.offset_left_smooth"),
        tr("form.animation.alpha")
    ]
    let options2_a = [
        "offset_up",
        "offset_down",
        "offset_right",
        "offset_left",
        "offset_up_back",
        "offset_down_back",
        "offset_left_back",
        "offset_right_back",
        "offset_up_smooth",
        "offset_down_smooth",
        "offset_left_smooth",
        "alpha"
    ]
    let options3 = [
        tr("form.style.panel"),
        tr("form.style.book"),
        tr("form.style.paper"),
        tr("form.style.panel_2"),
        tr("form.style.banner_red"),
        tr("form.style.banner_purple"),
        tr("form.style.banner_green"),
        tr("form.style.banner_gray"),
        tr("form.style.banner_black"),
        tr("form.style.ladrillo_red"),
        tr("form.style.ladrillo_purple"),
        tr("form.style.ladrillo_green"),
        tr("form.style.ladrillo_gray"),
        tr("form.style.ladrillo_black")
    ]
    let options3_a = [
        "panel",
        "book",
        "paper",
        "panel_2",
        "banner_red",
        "banner_purple",
        "banner_green",
        "banner_gray",
        "banner_black",
        "ladrillo_red",
        "ladrillo_purple",
        "ladrillo_green",
        "ladrillo_gray",
        "ladrillo_black"
    ]
    let opt = ["", "", 0, 11, 1, "@a",2*20,3*20,2*20]
    if (data.sourceEntity.getDynamicProperty("more_titles:data") !== undefined) {
        opt = JSON.parse(data.sourceEntity.getDynamicProperty("more_titles:data"))
    }
    form.textField(tr("form.display.title"), "", opt[0])
    form.textField(tr("form.display.subtitle"), "", opt[1])
    form.dropdown(tr("form.location.title"), options1, opt[2])
    form.dropdown(tr("form.animation.title"), options2, opt[3])
    form.dropdown(tr("form.style.title"), options3, opt[4])
    form.textField(tr("form.text.showTo"), tr("form.text.options"), opt[5])
    form.slider(tr("form.slider.start_time"),0,30*20,10,opt[6])
    form.slider(tr("form.slider.wait_time"),0,30*20,10,opt[7])
    form.slider(tr("form.slider.fade_time"),0,30*20,10,opt[8])
    form.submitButton(tr("form.show.title"))
    form.show(data.sourceEntity).then(async dat => {
        if (dat.canceled) return; //
        try {
            const title = dat.formValues[0]
            const subtitle = dat.formValues[1]
            const location = options1_a[dat.formValues[2]]
            const animation = options2_a[dat.formValues[3]]
            const style = options3_a[dat.formValues[4]]
            const shoWto = dat.formValues[5]
            const inTime = dat.formValues[6]
            const stayTime = dat.formValues[7]
            const outTime = dat.formValues[8]

            data.sourceEntity.setDynamicProperty("more_titles:data", JSON.stringify(dat.formValues))
            const titleStr = title.length > 99
                ? title.substr(0, 99).split(' ').slice(0, -1).join(' ')
                : title;
            const titlelenght = titleStr.length.toFixed().padStart(2, "0")
            const command = `/title ${shoWto} title ${style}:title_lenght:${titlelenght}${titleStr}${subtitle} #${location}# #${animation}#`
            const command2 = `/title ${shoWto} times ${inTime } ${stayTime} ${outTime}`
            await data.sourceEntity.runCommandAsync(command2)
            data.sourceEntity.runCommand(command)
        } catch (error) {
            world.getAllPlayers().find(pl => pl.id === data.sourceEntity.id).sendMessage(`§cOcurrio un error:${error}`)
        }
    })
})

function tr(str) {
    return { translate: str }
}